#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#define	OPT_ALL		1
#define	OPT_LONG	2
#define	OPT_PRINT	4
#define	OPT_VERBOSE	8

char	*sprintp(unsigned long, int);
int		checkCommand(char **, char *, int);
int		splitPath(char *, char *, char ***);
void	usage();

static char *sAppName="cType";

int main(int argc, char *argv[]) {
	int i, argCnt=1, optFlag=0, numCmd=0, numPathListItems=0;
	char **sCmdList=NULL, **sPathList=NULL, *s, *argStr, *optStr="alpv";

	while (--argc) {
		argStr=argv[argCnt++];
		if (*argStr == '-' && strlen(argStr)>1) {
			while (*++argStr) {
				if ((s=strchr(optStr,*argStr))==NULL) usage();
				optFlag |= 1 << (s-optStr); continue;
			}
		}
		sCmdList=realloc(sCmdList,(1+numCmd)*sizeof(char *));
		sCmdList[numCmd++]=argStr;
	}
	if (!numCmd) usage();
	if ((numPathListItems=splitPath((char *)getenv("PATH"), ";", &sPathList))<=0) {
		fprintf(stderr,"%s: internal error splitting PATH variable!\n", sAppName);
		exit(1);
	}
	for (i=0;i<numCmd;i++)
		checkCommand(sPathList, sCmdList[i], optFlag);
}

int splitPath(char *sPath, char *sSep, char ***sPathList) {
	int		numItems=0;
	char	*s, **sList=NULL;

	if ((s=strtok(sPath, sSep))==NULL) return 0;
	sList=realloc(sList,(1+numItems)*sizeof(char *));
	sList[numItems]=malloc(2);
	strcpy (sList[numItems++],".");
	do {
		if (*s=='"') s++;
		if (s[strlen(s)-1]=='"') s[strlen(s)-1]=0;
		if (s[strlen(s)-1]=='\\') s[strlen(s)-1]=0;
		sList=realloc(sList,(1+numItems)*sizeof(char *));
		sList[numItems]=malloc(1+strlen(s));
		strcpy (sList[numItems++],s);
	} while ((s=strtok(NULL, sSep))!=NULL);
	sList=realloc(sList,(1+numItems)*sizeof(char *));
	sList[numItems++]=NULL; *sPathList=sList;
	return numItems;
}

int checkCommand(char **sPathList, char *sCmd, int optFlag) {
	int	i, j, numFound=0;
	struct stat buf;
	char *sExtList[] = {
		"com","exe","bat","cmd","dll", NULL
	};

	for (i=0;sPathList[i];i++) {
		char sCommand[260];
		
		sprintf(sCommand,"%s\\%s", sPathList[i], sCmd);
		if (stat(sCommand,&buf)<0) {
			for (j=0;sExtList[j];j++) {
				sprintf(sCommand,"%s\\%s.%s", sPathList[i], sCmd, sExtList[j]);
				if (stat(sCommand,&buf)>=0) break;
			}
			if (!sExtList[j]) continue; // command NOT found!
		}
		if (!numFound || (optFlag & OPT_ALL)) { // first entry found, or successive and ALL Flag set
			printf ("%s is %s\n", sCmd, sCommand);
			if (optFlag & OPT_LONG) {
				char	dateStr[260];
				strftime(dateStr,sizeof(dateStr),"%d.%m.%Y %H:%M",localtime(&buf.st_mtime));
				printf ("%s %s %s\n", dateStr, sprintp(buf.st_size, 13), sCommand);
			}
		}
		numFound++;
	}
	return numFound;
}

char *sprintp(unsigned long ul, int len) {
	unsigned char outBuf[]="  .   .   .   .   ", *returnBuf=malloc(32), fmts[20];
	int	last, slen=strlen(outBuf);

	for (last=slen-1;ul;ul/=10, last--) {
		outBuf[last=(outBuf[last]=='.')?last-1:last]=(ul % 10)|'0';
	}
	if (slen > len) {
		sprintf (fmts,"%%%ds", len);
		sprintf (returnBuf,fmts,&outBuf[last+1]);
	} else strcpy(returnBuf, outBuf);
	return returnBuf;
}

void usage() {
	fprintf(stderr,"usage: %s [-options] command ...\n", sAppName);
	fprintf(stderr,"valid options are:\n\t-a = display [a]ll path/cmd combs\n\t-l = print (l)ong format of command\n\t-p = (p)rint content of command file\n\t-v = (v)erbose\n");
	exit (1);
}
